#define FIX_ADR 	0x7000
#define VRAMADR 	0x3c0000
#define VRAMDAT 	0x3c0002
#define VRAMINC 	0x3c0004
#define PAL_ADR 	0x400000
#define PAD1		0x300000


#define JOY_UP		0x0001
#define JOY_DOWN	0x0002
#define JOY_LEFT	0x0004
#define JOY_RIGHT	0x0008
#define BUTTON_A	0x0010
#define BUTTON_B	0x0020
#define BUTTON_C	0x0040
#define BUTTON_D	0x0080
#define START1		0x0100
#define SELECT1		0x0200
#define START2		0x0400
#define SELECT2		0x0800


int mypal[] = {
	0x0000,
	0x0FFF, /* used */
	0x0000, /* used */
	0x0DDD,
	0x0444,
	0x0888,
	0x0FF0,
	0x00FF,
	0x0F0F,
	0x05FF,
	0x0F6F,
	0x0F8F,
	0x056F,
	0x0FFF,
	0x0F66,
	0x06FF
};

void outtext(x,y, string, pal);
void loadpal(pal, nb);
void outFIX(from, to, pal);
void wait_sync();
int  read_joy1();
void BadRaz();
void ShowHex();


long vtimer;   /* VBL timer (used in startup.asm)*/
int oldpad;


/* It doesn't seems to be needed */
/* extern void Init1();
extern void Init2();
*/

void main()
{
   	register char *s;
   	register int pad, oldpad;
   	register int  curStep;
   	 
	loadpal(mypal, 1);
		
	s = (char *) 0x003A000B;
	*s = 1;

	outtext(1,2, "FIX char demo", 1);
	outtext(1,5, "Let see the FIX roms we load", 1);
	outtext(1,7, "BUTTON A load board FIX rom", 1);
	outtext(1,8, "BUTTON B load game FIX rom", 1);
	outtext(1,9, "LEFT jump to start of rom", 1);
	outtext(1,10, "RIGHT jump to start of rom", 1);
	outtext(1,11, "UP show previous part of rom", 1);
	outtext(1,12, "DOWN show next part of rom", 1);
	outtext(1,15, "Rename any -s1.rom or .378 rom", 1);
	outtext(1,16, "on pdpon-s1.rom to see the FIX", 1);
	outtext(1,17, "chars inside.", 1);
	outtext(10,20, "Kaneda", 1);


	
	curStep = 0;	
	oldpad = 0x0000;	
	
	while(!(pad = read_joy1()) );

	oldpad = pad;
	BadRaz();
	
	outFIX(curStep, curStep+384, 1);

	outtext(25,10, "Board", 1);
		
	while(1)
	{
		pad = read_joy1();
		
		if (oldpad != pad)
		{
			switch( pad & 0x03FF )
			{
				case JOY_UP:
					curStep-=384;
					if (curStep < 0 )	curStep = 0;
					outFIX(curStep, curStep+384, 1);
					break;					
				case JOY_DOWN:
					curStep+=384;
					if (curStep > (4096 - 384) )	curStep = 4096 - 384;
					outFIX(curStep, curStep+384, 1);
					break;
				case JOY_LEFT:
					curStep = 0;					
					outFIX(curStep, curStep+384, 1);
					break;
				case JOY_RIGHT:
					curStep = 4096 - 384;
					outFIX(curStep, curStep+384, 1);
					break;									
				case BUTTON_A:  
					s = (char *) 0x003A000B;
					*s = 1;
					outtext(25,10, "Board", 1);
					break;
				case BUTTON_B:
					s = (char *) 0x003A001B;
					*s = 1;
					outtext(25,10, "Game ", 1);
					break;
				case BUTTON_D:
					ShowHex();
					break;
			}
			
		
			wait_sync();
			oldpad = pad;
		
		}
	}
}


void ShowHex()
{
	outtext(1,2, "0x0000", 1);
	outtext(1,3, "0x0010", 1);
	outtext(1,4, "0x0020", 1);
	outtext(1,5, "0x0030", 1);
	outtext(1,6, "0x0040", 1);
	outtext(1,7, "0x0050", 1);
	outtext(1,8, "0x0060", 1);
	outtext(1,9, "0x0070", 1);
	outtext(1,10, "0x0080", 1);
	outtext(1,11, "0x0090", 1);
	outtext(1,12, "0x00A0", 1);
	outtext(1,13, "0x00B0", 1);
	outtext(1,14, "0x00C0", 1);
	outtext(1,15, "0x00D0", 1);
	outtext(1,16, "0x00E0", 1);
	outtext(1,17, "0x00F0", 1);
	outtext(1,18, "0x0100", 1);
	outtext(1,19, "0x0110", 1);
	outtext(1,20, "0x0120", 1);
	outtext(1,21, "0x0130", 1);
	outtext(1,22, "0x0140", 1);
	outtext(1,23, "0x0150", 1);
	outtext(1,24, "0x0160", 1);
	outtext(1,25, "0x0170", 1);
}

void BadRaz()
{
	int toWrite;
	int i, j, x, y;
	register int *pl;
	register int *pw;

   	x = 1;
   	y = 2;
   	
   	
	toWrite = FIX_ADR; /* we write to the FIX plane */
	toWrite +=y;
	toWrite +=(x*0x20); /* X+0x20 => X++ */
	
	pl = (int *) VRAMINC;
	*pl = 0x20; /* increment X by 1 */
	
	
	pl = (int *) VRAMADR;
        *pl = toWrite;

        pw = (int *) VRAMDAT;	
        
	for (i=2; i< 24;i++) 
	{		
        	
        	for (j = 1; j < 32; j++)
        		*pw = 0;

		y++;
		toWrite = FIX_ADR; /* we write to the FIX plane */
		toWrite +=y;
		toWrite +=(x*0x20); /* X+0x20 => X++ */
		pl = (int *) VRAMADR;
		*pl = toWrite;
	        pw = (int *) VRAMDAT;	

	}
}

void wait_sync()
{
	vtimer = 0;
    	while (!vtimer);
    	vtimer = 0;
}


int read_joy1()
{
	register unsigned int pad, temp;
   	register unsigned char *s;
	
	pad = 0x0000;
	
	s = (unsigned char *) 0x380000;
	pad = *s;
	pad = pad << 8;
		
	s = (unsigned char *) PAD1;
	pad |= (*s);
	

	
/*	pad |= temp; */
	
	/*pad = (~pad);*/
	
	return ( ~(pad) );
}



void outFIX(from, to, pal)
int from;
int to;
int pal;
{
	int toWrite;
	int i, j, x, y;
	register int *pl;
	register int *pw;

   	x = 8;
   	y = 2;
   	
   	
	toWrite = FIX_ADR; /* we write to the FIX plane */
	toWrite +=y;
	toWrite +=(x*0x20); /* X+0x20 => X++ */
	
	pl = (int *) VRAMINC;
	*pl = 0x20; /* increment X by 1 */
	
	
	pl = (int *) VRAMADR;
        *pl = toWrite;

        pw = (int *) VRAMDAT;	
        
	for (i=from; i< to;i+=16) 
	{		
        	
        	for (j = i; j < (i+16); j++)
        		*pw = (j + (pal << 12) );

		y++;
		toWrite = FIX_ADR; /* we write to the FIX plane */
		toWrite +=y;
		toWrite +=(x*0x20); /* X+0x20 => X++ */
		pl = (int *) VRAMADR;
		*pl = toWrite;
	        pw = (int *) VRAMDAT;	

	}
}	




void outtext(x,y, string, pal)
int x;
int y;
char *string;
int pal;
{
	int toWrite;
	int i;
        register char *s;
	register int *pl;
	register int *pw;

	for (s = string; *s; ++s);
   	
	toWrite = FIX_ADR; /* we write to the FIX plane */
	toWrite +=y;
	toWrite +=(x*0x20); /* X+0x20 => X++ */
	
	pl = (int *) VRAMINC;
	*pl = 0x20; /* increment X by 1 */
	
	
	pl = (int *) VRAMADR;
       *pl = toWrite;

        pw = (int *) VRAMDAT;	
        
	for (i=0; i<(s - string);i++)
	{		
        	*pw = (string[i] + (pal << 12) );
	}
}	

void loadpal(pal, nb)
int pal[16];
int nb;
{
	register int *pl;
	char i;

	pl = (int *) ( PAL_ADR  ); /*| nb << 5 );*/
	pl += (16*nb); 
	 
	for (i=0; i<11;i++)
	{
		*pl = pal[i];
		pl++;
	}
}	