/******************************************

 View NeoGeo GFX

 Exit code
 0    Ok
 3    Bad usage / Exe only launched
 5    Unknow option


 History
 10Jan01	Initial release

 *******************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include "kgraph.h"
//#include "interac.h"
#include <dos.h>
#include <pc.h>
#include <keys.h>



int AccessROM (char *);                  // func to check BMP file
void ProcessFIX (char *);
char swapc( char );
void Show(long , char *);

uchar cType;
uint MaxHSize;                  //Max Tile HSize (32 or BMP Hsize)
uint MaxVSize;

int main (int argc, char *argv[])
{
	int argn = 1;

	argc--;
	
	cType=2;
	
	if (argc < 2)
	{
		printf("\n\aUsage: NeoGFX [-f] [-g] Romimage\n");
		printf("\t-f  Rom image is a FIX rom.\n");
		/* printf("\t-g  Rom image is a GFX rom.\n\n"); */
		/* printf("\tno option  Rom image is autodetected through it's size.\n\n");*/
		printf("NeoGFX 0.1 by Kaneda\n");
		exit(3);
	}



	while (argv[argn][0] == '-' && argc)
	{
		switch (argv[argn][1])
		{
		    case 'f':
				cType=0;
				break;
		 /*   case 'g':
				cType = 1;
				break;*/
		    default:
				printf ("*ERROR*\t\tUnknown option '%c'\n", argv[argn][1]);
				exit (5);
				break;
		}
		argn++;
		argc--;
	}

/*	if (cType==2)  = AccessROM(argv[argn]); */


	clrscr();


	printf("\nFILE: %s",argv[argn]);
	printf("\n");
	printf("\nType of ROM image: ");

	if (cType == 0)
		printf("FIX rom");
	else if (cType == 1)
		printf("GFX rom");
	printf("\n");

	printf("\n\tPress any Key...\n");
	/* must put a \n else you won't see it...Getch() bug? */
	getch();

	ProcessFIX(argv[argn]); 	//see below

	printf("See you soon for the GFX rom support...\n");
	
	return(0);
};


//////////////////////////////////////////////////////////////////////////
// AccessBMP(char *Filename)
//             This routine opens the BMP file and checks to see if it's
//             okay to use, i.e 16-Colors & Uncompressed.
//             BMP file structures should be defined as global
//             in the calling routine.
//////////////////////////////////////////////////////////////////////////
int AccessROM(char *BMPFile)
{
	FILE *Fn;
	int errorcode;


	Fn = fopen(BMPFile,"rb");               // Open up BMP image file

	return(errorcode);
};

//////////////////////////////////////////////////////////////////////////
// ProcessBMP(char *Filename)
//             This routine opens the BMP file, displays it pixel by
//             pixel and let the user do his business.
//             Call AccessBMP before using this routine.  BMP file
//             structures should be defined as global vars in the calling
//             routine.
//////////////////////////////////////////////////////////////////////////
void ProcessFIX(char *BMPFile)
{
	uchar IsFinish = 0;
	long Pos =0;


    	KSetVideoMode(0x13);

/*
	for (i=0;i<16;i++)
	{
		fread(&BMPRGBQuad,sizeof(BMPRGBQuad),1,Fn);
        	i_b = BMPRGBQuad.rgbBlue;
		i_v = BMPRGBQuad.rgbGreen;
		i_r = BMPRGBQuad.rgbRed;

        	KSetColor(i, i_r>>2, i_v>>2, i_b>>2);

	}
*/	
	Show(Pos, BMPFile);

	while (!IsFinish)
	{		
		switch(getkey())
		{
			case K_Escape:
				IsFinish=1;
			 	break;
			case K_Up:
				if (Pos>=16*32)
				{	
					Pos-=16*32;
					Show(Pos, BMPFile);
				}					
				break;
			case K_PageUp:
				if (Pos>=10*16*32)
					Pos-=10*16*32;
				else
					Pos=0;
					
				Show(Pos, BMPFile);
				break;
			case K_Down:
				if (Pos<=4096*32)
				{	
					Pos+=16*32;
					Show(Pos, BMPFile);
				}					
				break;
			case K_PageDown:
				if (Pos<=(4096-10)*32)
					Pos+=10*16*32;
				else
					Pos=(4096-10)*32;					
				Show(Pos, BMPFile);
				break;
			
		}
	}

	KSetVideoMode(0x03);
};


char swapc( char toswap )
{
	char a,b;

	a = toswap;
	b = a;
	a = a>>4;
	a |= (b<<4);
	return a;
};

void Show(long Pos, char *BMPFile)
{
	FILE *Fn;
	uint x, y, k;
	char Pixel[4*8];
	uchar i_r, i_v, i_b;
	long curPos;
	uint PosX = 70;
	uint PosY = 20;

	Fn = fopen(BMPFile,"rb");

	curPos = Pos;
	fseek(Fn,curPos, SEEK_SET);
	
	while(curPos < Pos+(16*15*32) )
	{
		fread(&Pixel,sizeof(Pixel),1,Fn);		
		x=4;
		y=0;
		for (k=0; k < 32; k++)
		{
       			// 11110000 in rom, 00000000 11111111 in screen
       			KWritePix(0, (Pixel[k]&0xf0)>>4, PosX+x+1, PosY+y);
       			KWritePix(0, Pixel[k]>>4, PosX+x, PosY+y);
       			y++;
       			if (y==8)
       			{
       				y=0;
       				x+=2;
       			}
       			if (x==8)	x=0;       			       				
		}
		curPos +=32;
		PosX+=10;
		if (PosX >= 230)
		{
			PosX = 70;
			PosY +=10;
		}
	}
	/* each line are coded long by long so if width/2 ('coze 4bit) % size(long) > 0 then add what less */ 
    	fclose(Fn);
}	