#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "interac.h"
#include "kgraph.h"
#include "bmp.h"

extern BITMAPINFOHEADER BMPInfo;

extern uint FirstTile;
extern uint SpriteOrMap;
extern uint MaxHSize;
extern uint MaxVSize;

// define my Selector
struct stSelec{
	uint X;      	//X,Y position of Top-Left
	uint Y;
	uint HSize;
	uint VSize;
	uint Color;	// Remeber!! It's the BMP Palette
	uint Save[640+480];  //Max size to avoid error
}Selector;

uint TileStored;	//Number of tiles stored

void Interact(char *BMPFile)
{
	uint IsFinish;	//To end the While loop ie when ESC
	uint tmp;

	IsFinish=0;
	TileStored=0;

	InitSelector();

	while(!IsFinish)
	{
		if(kbhit())
		{
			switch(getch())
			{
				// incremente the number of the color index
				case '+':
					Selector.Color++;
					if (Selector.Color == 16) Selector.Color = 0;
					DrawSelector(Selector.HSize, Selector.VSize, Selector.X, Selector.Y);
					break;
				// decremente
				case '-':
					if (Selector.Color == 0)
						Selector.Color = 15;
					else
						Selector.Color--;
					DrawSelector(Selector.HSize, Selector.VSize, Selector.X, Selector.Y);
					break;
				// Selector width ++
				case 'r':
					if (Selector.HSize == MaxHSize)
						tmp = 8;
					else
						tmp = Selector.HSize + 8;
					DrawSelector(tmp, Selector.VSize, Selector.X, Selector.Y);
					break;
				// Selector width --
				case 't':
					if (Selector.HSize == 8)
						tmp = MaxHSize;
					else
						tmp = Selector.HSize - 8;
					DrawSelector(tmp, Selector.VSize, Selector.X, Selector.Y);
					break;
				// Selector Height ++
				case 'f':
					if (Selector.VSize == MaxVSize)
						tmp = 8;
					else
						tmp = Selector.VSize + 8;
					DrawSelector(Selector.HSize, tmp, Selector.X, Selector.Y);
					break;
				// Selector Height --
				case 'g':
					if (Selector.VSize == 8)
						tmp = MaxVSize;
					else
						tmp = Selector.VSize - 8;
					DrawSelector(Selector.HSize, tmp, Selector.X, Selector.Y);
					break;
				// Up
				case 72:
					if (Selector.Y>0)
					{
						HideSelector();
						Selector.Y--;
						ShowSelector();
					}
					break;
				// Left
				case 75:
					if (Selector.X>0)
					{
						HideSelector();
						Selector.X--;
						ShowSelector();
					}
					break;
				// Right
				case 77:
					if (Selector.X<BMPInfo.biWidth)
					{
						HideSelector();
						Selector.X++;
						ShowSelector();
					}
					break;
				// Down
				case 80:
					if (Selector.Y<BMPInfo.biHeight)
					{
						HideSelector();
						Selector.Y++;
						ShowSelector();
					}
					break;
				// ENTER = save the select zone
				case 13:
					HideSelector();
					Store(BMPFile);
					ShowSelector();
					break;
				// ESC = quit
				case 27:
					IsFinish = 1;
					HideSelector();
					break;
			}

		}
	}
}


// Default values of Selector
void InitSelector()
{
	Selector.X = 0;
	Selector.Y = 0;
	Selector.HSize = 8;
	Selector.VSize = 8;
	Selector.Color = 0;

	// Show selector create the default Save
	ShowSelector();
}

// Print the selector to screen
// Hide it before to erase the last one and to redraw the last zone
void DrawSelector(uint HSize, uint VSize, uint X, uint Y)
{
	HideSelector();

	Selector.X = X;
	Selector.Y = Y;
	Selector.HSize = HSize;
	Selector.VSize = VSize;

	ShowSelector();
}


// Erase the Selector (on screen) by reprinting the zone
void HideSelector()
{
	uint i,j;


	for (i = Selector.X; i < Selector.X+ Selector.HSize; i+=2)
	{
		KWritePix(0, Selector.Save[i-Selector.X], i, Selector.Y);
		KWritePix(0, Selector.Save[i-Selector.X+1], i, Selector.Y+Selector.VSize-1);
	}

	for (j = Selector.Y; j < Selector.Y+Selector.VSize; j+=2)
	{
		KWritePix(0, Selector.Save[Selector.HSize + j-Selector.Y], Selector.X, j);
		KWritePix(0, Selector.Save[Selector.HSize + j-Selector.Y+1], Selector.X+Selector.HSize-1,j);
	}

}


// Print the selector to screen AFTER saving the zone where it must be print
// I don't save all the zone (else mem error when 640*480), only the outline
void ShowSelector()
{
	uint i,j;


	for (i = Selector.X; i < Selector.X+ Selector.HSize; i+=2)
	{
		Selector.Save[i-Selector.X] = KReadPix(0, i, Selector.Y);
		Selector.Save[i-Selector.X+1] = KReadPix(0, i, Selector.Y+Selector.VSize-1);
	}

	for (j = Selector.Y; j < Selector.Y+Selector.VSize; j+=2)
	{
		Selector.Save[Selector.HSize + j-Selector.Y] = KReadPix(0, Selector.X, j);
		Selector.Save[Selector.HSize + j-Selector.Y+1] = KReadPix(0, Selector.X+Selector.HSize-1,j);
	}

	for (i = Selector.X; i < Selector.X+ Selector.HSize; i+=2)
	{
		KWritePix(0, Selector.Color,i,Selector.Y);
		KWritePix(0, Selector.Color,i,Selector.Y+Selector.VSize-1);
	}

	for (j = Selector.Y; j < Selector.Y+Selector.VSize; j+=2)
	{
		KWritePix(0, Selector.Color,Selector.X,j);
		KWritePix(0, Selector.Color,Selector.X+Selector.HSize-1,j);
	}
}


// Save the selected zone in ASM
// Hide the selector else you'll save it too!!
void Store(char *BMPFile)
{
	FILE *sp;
	uint IdxH, IdxV, IdxTV, IdxTH, i, j, k, l;
	char buff[12];

	strcpy(buff, BMPFile);
	strcat(buff,".s");
	sp = fopen(buff,"ab+");  //Add 'coz we already save the pal



	// sprite 0 = transparent

	if (FirstTile)
	{
        fprintf(sp,"\n\t.globl _Empty_Tile\n\n_Empty_Tile:\n");

		fprintf(sp,"\tdc.l\t$00000000\n");
		fprintf(sp,"\tdc.l\t$00000000\n");
		fprintf(sp,"\tdc.l\t$00000000\n");
		fprintf(sp,"\tdc.l\t$00000000\n");
		fprintf(sp,"\tdc.l\t$00000000\n");
		fprintf(sp,"\tdc.l\t$00000000\n");
		fprintf(sp,"\tdc.l\t$00000000\n");
		fprintf(sp,"\tdc.l\t$00000000\n\n");
		fprintf(sp,"* --------------------------\n");
		FirstTile = 0;  // to create only one empty tile
	}

	fprintf(sp,"\n\t.globl _%s%d_HSize\n\n_%s%d_HSize:", BMPFile, TileStored, BMPFile, TileStored);
	fprintf(sp,"\tdc.w\t$%0.1X\n",Selector.HSize/8);

	fprintf(sp,"\n\t.globl _%s%d_VSize\n\n_%s%d_VSize:", BMPFile, TileStored, BMPFile, TileStored);
	fprintf(sp,"\tdc.w\t$%0.1X\n",Selector.VSize/8);

	fprintf(sp,"\n\t.globl _%s%d\n\n_%s%d:\n", BMPFile, TileStored, BMPFile, TileStored);

	if (!SpriteOrMap)
	{
		for (IdxV= Selector.Y; IdxV < Selector.Y+Selector.VSize; IdxV+=8)
		{
			for (IdxH= Selector.X; IdxH < Selector.X + Selector.HSize; IdxH+=8)
			{
				for (IdxTV=0;IdxTV<8;IdxTV++)
				{
					fprintf(sp,"\tdc.l\t$");
					for (IdxTH=0; IdxTH< 8; IdxTH++)
						fprintf(sp,"%0.1X",KReadPix(0,IdxTH+IdxH,IdxTV+IdxV) );
					fprintf(sp,"\n");

				}
				fprintf(sp,"\n* --------------------------\n");
			}
		}
	}
	else
	{
		for (l=Selector.X;l<Selector.X+Selector.HSize;l+=8)
		{
			for (k=Selector.Y; k< Selector.Y+Selector.VSize; k+=8)
			{
				for (i=0;i<8;i++)
				{
					j=0+l;
					fprintf(sp,"\tdc.l\t$");
					fprintf(sp,"%0.1X",KReadPix(0, j++, i+k));
					fprintf(sp,"%0.1X",KReadPix(0, j++, i+k));
					fprintf(sp,"%0.1X",KReadPix(0, j++, i+k));
					fprintf(sp,"%0.1X",KReadPix(0, j++, i+k));
					fprintf(sp,"%0.1X",KReadPix(0, j++, i+k));
					fprintf(sp,"%0.1X",KReadPix(0, j++, i+k));
					fprintf(sp,"%0.1X",KReadPix(0, j++, i+k));
					fprintf(sp,"%0.1X\n",KReadPix(0,j,i+k));
				}
				fprintf(sp,"\n* --------------------------\n");
			}
		}
	}

	TileStored++;

	fclose(sp);
}
