;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	CDoty Neo Geo First Demo commented
;;;;
;;;;	More info on www.arcadedev.com
;;;;	
;;;;	Some stuff to remember when you write in VRAM
;;;;
;;;;	write at 0x7000 to 0x7a00
;;;;	1 WORD		pppp ssss ssss ssss	where p = palette number and
;;;;						s = sprite/tile number
;;;;	Tiles are 8x8 and come from FIX rom
;;;;	7000 is (0,0)
;;;;	7001 is (0,1)
;;;;	701F is (0,31)
;;;;	7020 is (1,0)
;;;;			so for a X+1, you need to write at adr+0x20
;;;;
;;;;
;;;;	write at 0x00000 to 0xDFFFF
;;;;	1 DWORD		0xSSPF	where S = sprite/tile number,
;;;;				P = palette number and F=flip and special
;;;;	Tiles are 16x16 (???? 4 tiles of 8x8 ????) and come from GFX rom
;;;;	00000 is (0,0)
;;;;	00002 is (0,1)
;;;;	0003E is (0,31)
;;;;	00040 is (1,0)
;;;;			so for a X+1, you need to write at adr+0x40
;;;;
;;;;
;;;;
;;;;	write at 0x8000,0x8200,0x8400 to 0x81FF,0x83FFF,0x85FFF
;;;;	1 WORD		see neogeo doc
;;;;
;;;;	0x8?00 is for sprite block 0
;;;;	0x8?02 is for sprite block 1
;;;;
;;;;	What i don't understand is the link between 0x8000 and 0x00000
;;;;	is it
;;;;	0x8000 point to 0x00000
;;;;	0x8002 point to 0x00080
;;;;	.....????
;;;;
;;;;
;;;;	Kaneda (with permission of CDoty)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    
    INCLUDE "defines.inc"
   
    dc.l $0010F300	;Stack Ptr
    dc.l $00C00402	;InitialPC 402 in BIOS is a jmp to 11002
    
    dc.l $00C00408	;?? samething as Initial PC?
    dc.l $00C0040E  	;?? samething as Initial PC?
    						  
    dc.l $00C00414	;Ptr to debugging switch     			
        
    dc.l $00C0041A,$00C0041A,$00C0041A,$00C0041A	; ?
    dc.l $00C00420,$00C00426,$00C00426,$00C00426	; ? all these calls
    dc.l $00C00426,$00C00426,$00C0042C,$00C00426	; ? make a jump 
    dc.l $00C00426,$00C00426,$00C00426,$00C00426	; ? to c11002
    dc.l $00C00426,$00C00426,$00C00426,$00C00432	; ?
    
    dc.l VBlank,	Irq2,$00000000  ;Vertical blank ptr=VBlank
    					;IRQ2 ptr=Irq2(see below)
    					
    dc.l $00000000,$00000000,$00000000,$00000000
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    
    ;0x100
    dc.b "NEO-GEO", $00			;Magic bytes
    dc.w $0202				;NGH number
    dc.w $0010, $0000
    dc.w $0010 				;ptr to debugging switch
    dc.w $0000
    dc.w $0100				;starting sprite number (0x100 rsv for NeoGeo logo)
    dc.w $0000
    
    dc.l JapConfig 		; Japanese Config
    dc.l USConfig		; US Config
    dc.l EspConfig		; Espagnol config

    jmp     Start			;Entry point of prgm
    jmp     Start2
    jmp     Start3

    ;0x127
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF

    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF

    dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF

    dc.w $0000

    dc.l SCODE 					  ;Ptr to security code

SCODE:
    dc.l $76004A6D,$0A146600,$003C206D,$0A043E2D  ;Securty code
    dc.l $0A0813C0,$00300001,$32100C01,$00FF671A
    dc.l $30280002,$B02D0ACE,$66103028,$0004B02D
    dc.l $0ACF6606,$B22D0AD0,$67085088,$51CFFFD4
    dc.l $36074E75,$206D0A04,$3E2D0A08,$3210E049
    dc.l $0C0100FF,$671A3010,$B02D0ACE,$66123028
    dc.l $0002E048,$B02D0ACF,$6606B22D,$0AD06708
    dc.l $588851CF,$FFD83607
    dc.w $4e75

;when VBlanck
VBlank:
    btst    #7, $10fd80		;bit 7= 1 when NeoGeo logo is displayed
    bne     DisplayedLogo				

    move.l  #$c00438, a0
    jmp     (a0)		;jmp in bios in NeoGeo logo display function

DisplayedLogo:
    move.w  #4, $3c000c		;IRQ 4 acknoledge?
    move.b  d0, $300001		;??? watchdog???
    move.b  #1, VertBlank	;Vertical Blank occurs
    rte


JapConfig:
USConfig:
EspConfig:
	dc.b "0123456789ABCDEF"
	dc.l $FFFFFFFF
	dc.w $0364
	dc.l $14132401

	
;when Irq2
Irq2:
    rte

;Entry point
Start:
    jsr     Setup

;write Message text
    lea     Message, a2
    move.w  #15, d1
    move.w  #36, d0

    move.w  #1, d3             ; X Position of 10
    asl.l   #5, d3             ; x *= 0x20 (since +1 = +0x20)
    add.w   #10, d3            ; Y Position
    add.w   #$7000, d3         ; Sprite Offset    0x7000 is the FIX plane
    move.w  d3, d4
    move.w  #$0000, d6

MessageOuterLoop:
MessageInnerLoop:
    move.w  d3, $3c0000		; where to write in VRAM
    move.w  #$32e0, d7          ; Palette 3 and index base = 0x2e0 
    				;(font start at 0x2e0 in PuzzleDPon FIX rom)
    move.b  (a2)+, d6
    add.w   d6, d7
    move.w  d7, $3c0002
    add.l   #$20, d3		; x+1
    dbra    d0, MessageInnerLoop; for each column
    move.w  #36, d0
    addq    #1, d4		; y+1
    move.l  d4, d3
    dbra    d1, MessageOuterLoop; for eache line

;same thing for Members text
    lea     Members, a2
    move.w  #3, d1
    move.w  #36, d0

    add.w   #1, d4
    move.l  d4, d3

MembersOuterLoop:
MembersInnerLoop:
    move.w  d3, $3c0000
    move.w  #$32e0, d7          ; Palette number 
    move.b  (a2)+, d6
    add.w   d6, d7
    move.w  d7, $3c0002
    add.l   #$20, d3
    dbra    d0, MembersInnerLoop
    move.w  #36, d0
    addq    #1, d4
    move.l  d4, d3
    dbra    d1, MembersOuterLoop

    move.w  #$8010, $3c0000	; start to write at 0x8010
    move.w  #$200,  $3c0004	; increment VRAM pos by 0x200
    move.w  #$0fff, $3c0002	; 8010 = Full size for sprite 
    move.w  #$fc0e, $3c0002     ; Normally $f80e
    				; 0xE sprite in the bank
    				; Ypos = FC0E >> 7 = 5004    			
    move.w  #$440, $3c0002	; Xpos = 440 >> 7 = 8

    move.w  #$8011, d1
    move.w  #18, d0		; sprite width -1

SpriteMapLoop:
    move.w  d1, $3c0000
    move.w  #$0fff, $3c0002	; full size/zoom
    move.w  #$40, $3c0002	; bit 6 = 1 : next sprite at right
    add.w   #1, d1
    dbra    d0, SpriteMapLoop

    move.w  #$1, $3c0004	; VRAM inc by 1
    lea     ChaosMap, a5
    move.w  #$0400, a0
    move.w  a0, a1

    move.w  #3, d4

ChaosOuterLoop:
    move.w  #19, d5

ChaosInnerLoop:
    move.w  a0, $3c0000		; loc to write a0
    move.w  (a5)+, $3c0002	; first word = sprite number
    move.w  #$0000, $3c0002	; second word = palette(0) and flip(0)
    add.w   #64, a0     	; x+1
    dbra.w  d5, ChaosInnerLoop

    add.w   #2, a1		; y+1
    move.w  a1, a0

    dbra.w  d4, ChaosOuterLoop

;; same thing    
    lea     TilesMap, a5

    move.w  #11, d4

TilesOuterLoop:
    move.w  #18, d5

TilesInnerLoop:
    move.w  a0, $3c0000
    move.w  (a5)+, $3c0002
    move.w  #$0100, $3c0002
    add.w   #64, a0     
    dbra.w  d5, TilesInnerLoop

    add.w   #2, a1
    move.w  a1, a0

    dbra.w  d4, TilesOuterLoop


    move.w  #$8100, $3c0000	; write at $8100
    move.w  #$200,  $3c0004	; inc by $200
    move.w  #$0FFF, $3c0002	; Full size
    move.w  #$F20E, $3c0002     ; Normally $f80e
    				; 0x0E sprite in the bank
    				; y = $F20E >> 7
    move.w  #$2800, $3c0002	; x = $2800 >> 7

    move.w  #$8101, d1
    move.w  #8, d0

MovingMapLoop:
    move.w  d1, $3c0000
    move.w  #$0FFF, $3c0002	; full size
    move.w  #$40, $3c0002	; bit 6 = 1   (next tile right)
    add.w   #1, d1
    dbra    d0, MovingMapLoop	; for $8101 to $8109 

    move.w  #$1,  $3c0004	; inc by $1

    move.w  #$4000, a0

    move.w  #157, d0
    move.w  #167, d1

    move.w  #9, d5

MovingLoop:
    move.w  a0, $3c0000		; write at (a0)

    ;0
    move.w  d0, $3c0002		; sprite number = d0
    move.w  #$0200, $3c0002	; palette 2 & no flip

    add.w   #1, d0		

    ;1
    move.w  d1, $3c0002		; sprite number = d1
    move.w  #$0200, $3c0002	; palette 2 & no flip

    add.w   #1, d1

    ;2
    move.w  #177, $3c0002	; sprite number = 177
    move.w  #$0200, $3c0002	; pallete  & no flip

    ;3
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;4
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;5
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;6
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;7
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;8
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;9
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;A
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;B
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;C
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;D
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;E
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    ;F
    move.w  #177, $3c0002
    move.w  #$0200, $3c0002

    add.w   #$40, a0		; x+ 1

    dbra.w  d5, MovingLoop

    move.b  #0, VertBlank	;
    move.b  #0, Direction	;	Init values
    move.b  #0, Flip		;

    move.w  #$2000, sr		;?????? A7 = user stack pointer

Loop:
    cmp.b   #1, VertBlank    	; wait sync
    bne     Loop

    move.b  $300000, d0		; d0 = controler 1 status
    not.b   d0			; invert bits <= DON'T FORGET THIS

    btst    #2, d0		; bit 2 = Left  so if bit 2 = 1 then NotLeft
    beq     NotLeft

    ;move left
    move.w  #$8500, $3c0000
    move.w  $3c0002, d1		; read current X

    cmp.w   #128, d1        	; 1 * 128 (128 = 1 << 7)
    ble     EndInput

    sub.w   #128, d1		; if x > 1, x-1

    move.w  #$8500, $3c0000	; write new X
    move.w  d1, $3c0002

    bra     EndInput

NotLeft:
    btst    #3, d0		; bit 3 = Right so if bit 3 = 1 then NotRight
    beq     EndInput

    ;move right
    move.w  #$8500, $3c0000	; read curr x
    move.w  $3c0002, d1

    cmp.w   #20480, d1  	; 160 * 128 (160 = 320 - Width*TileWidth 
    				;		 = 320 - 10*16 = 320 - 160)
    bge     EndInput

    add.w   #128, d1		; if (x+width) < 320, x+1

    move.w  #$8500, $3c0000	; write new x
    move.w  d1, $3c0002

EndInput:
    move.b  #0, VertBlank   	; reset VBlanc status

    cmp.b   #1, Direction	
    beq     GoingDown
    
    ;Rotate up
    move.w  #$8100, $3c0000
    move.w  $3c0002, d1		; read cur zoom
    move.w  d1, d3
    and.w   #$00ff, d1		; d1 = Y zoom
    and.w   #$ff00, d3		; d3 = X zoom

    cmp.w   #$00, d1		; if zoom = 0%
    beq     ResetDown

    sub.w   #$0f, d1		; y zoom -1

    move.w  #$8100, $3c0000

    or.w    d3, d1		; restor x zoom
    move.w  d1, $3c0002		; write new zomm

    move.w  #$8300, $3c0000	; to be sure the rotate in centered ypos-1
    				; ??? why not +1 ???
    move.w  $3c0002, d1

    sub.w   #128, d1 

    move.w  #$8300, $3c0000
    move.w  d1, $3c0002

    jmp     Repeat

; change direction 
ResetDown:
    move.b  #1, Direction
    move.w  #$8100, $3c0000

    or.w    d3, d1
    move.w  d1, $3c0002

    jsr     FlipLogo

    jmp     Repeat

GoingDown:			; same thing but with y zoom + 1
    move.w  #$8100, $3c0000
    move.w  $3c0002, d1
    move.w  d1, d3
    and.w   #$00ff, d1
    and.w   #$ff00, d3

    cmp.w   #$FF, d1
    beq     ResetUp

    add.w   #$0f, d1		; y zoom + 1

    move.w  #$8100, $3c0000

    or.w    d3, d1
    move.w  d1, $3c0002

    move.w  #$8300, $3c0000	; center the sprite
    move.w  $3c0002, d1

    add.w   #128, d1 

    move.w  #$8300, $3c0000
    move.w  d1, $3c0002

    jmp     Repeat

ResetUp:
    move.b  #0, Direction
    move.w  #$8100, $3c0000

    or.w    d3, d1
    move.w  d1, $3c0002

Repeat:
    bra     Loop

Start2:
    rts

Start3:
    rts

;Init
Setup:
    move.w  #0, $3c0006		;???
    move.w  #7, $3c000c		;IRQ 7 acknoledge????

    jsr     SetupPalette

    move.l  #$c004c2, a0	; jump in BIOS ??????
    jsr     (a0)

    movem.l d0-d6, -(a7)	; save data register

    move.w  #$7000, d0		; d0 = (0,0)
    move.w  #$701f, d1		; d1 = (0,31)
    move.w  #$7001, d4		; d4 = (0,1)
    move.w  #$701e, d5		; d5 = (0, 30)
    move.w  #$20, d2
    move.w  #$20, d3
    move.w  #$27, d7

SetupLoop:
    move.w  d0, $3c0000
    nop				; WHY NOP ?
    move.w  d2, $3c0002
    nop
    move.w  d1, $3c0000
    nop
    move.w  d2, $3c0002
    nop
    move.w  d4, $3c0000
    nop
    move.w  d2, $3c0002
    nop
    move.w  d5, $3c0000
    nop
    move.w  d2, $3c0002
    nop
    add.w   d3, d0		; d0 + 0x20 = x0+1
    add.w   d3, d1		; x1+1
    add.w   d3, d4		; x4+1
    add.w   d3, d5		; x5+1
    dbra    d7, SetupLoop	; for the 40 (0x27 ie 320/8) columns

    movem.l (a7)+, d0-d6	; restore data register

    move.l  #$c004c8, a0	; jump in bios memory ?????
    jsr     (a0)

    rts

;Init the palette
SetupPalette:
    lea     $400000, a0		;a0 = ptr to NeoGeo palette
    lea     Palettes, a1	;a1 = ptr to our palette
    move.w  #128, d7	;d7 = palette size
    asr.w   #5, d7		;each pal = 16words so Palnumb = d7>>5 

; for copy the d7 palette of 16 colors
DoPalette:
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    move.w  (a1)+, (a0)+
    dbra    d7, DoPalette

    rts

FlipLogo:
    move.w  #1, $3c0004		;inc vram to 1

    move.w  #$4000, a0
    move.w  #9, d5

    move.b  Flip, d0
    add.b   #1, d0
    and.b   #1, d0
    move.b  d0, Flip		; Flip = 1 OR 0

    cmp.b   #1, d0
    bne     Normal		; Flip 0 = normal

    move.w  #167, d0		; flip
    move.w  #157, d1
    move.w  #$0202,d2		; pal 2, y flip

    jmp     FlipLoop

Normal:
    move.w  #157, d0		; no flip
    move.w  #167, d1
    move.w  #$0200,d2		; pal 2, no flip
    

;write new values
FlipLoop:
    move.w  a0, $3c0000

    move.w  d0, $3c0002
    move.w  d2, $3c0002

    add.w   #1, d0

    move.w  d1, $3c0002
    move.w  d2, $3c0002

    add.w   #1, d1

    add.w   #$40, a0

    dbra    d5, FlipLoop

    rts

;            *        1         2         3     *
;           0123456789012345678901234567890123456
Message:
    dc.b   "   WELCOME TO THE 10TH ANNIVERSARY   "
    dc.b   " CHAOS DEMO, AND FIRST EVER NEOGEO   "
    dc.b   " DEMO. THIS THE SECOND CHAOS DEMO ON "
    dc.b   " AN ARCADE GAME SYSTEM. THE CPS-1    "
    dc.b   " SYSTEM IS THE NEXT PLANNED SYSTEM TO"
    dc.b   " BE BLESSED WITH A CHAOS RELEASE. :) "
    dc.b   "                                     "
    dc.b   " NOW TO GET A HOLD OF A JAMMA RIG TO "
    dc.b   " TEST THE DEMOS ON A REAL SYSTEM.    "
    dc.b   "                                     "
    dc.b   " EVENTUALLY WE RE PLANNING ON DOING  "
    dc.b   " SOME REAL ARCADE GAMES.             "
    dc.b   "                                     "
    dc.b   " CONTACT RASTER AT CDOTY@NETZERO.NET "
    dc.b   "                                     "
    dc.b   " LONG LIVE POOPER*****CODED BY RASTER"

Members:
    dc.b   "              MEMBERS:               " 
    dc.b   "     RASTER            PICKSTER      "
    dc.b   "           SECTOR SMASHER            "

SpriteNumber:
    dc.w 14			;used only for memo

Palettes:
    INCBIN "chaos.pal"
    INCBIN "tiles.pal"
    INCBIN "sprite.pal"
    dc.w   $0000,$000C,$7FFF,$0000,$0000,$0000,$0000,$0000
    dc.w   $0000,$7FFF,$000C,$0000,$0000,$0000,$0000,$0000
EndPalettes:

ChaosMap:
    INCBIN "chaos.mp1"
ChaosMapEnd:

TilesMap:
    INCBIN "tiles.mp1"
TilesMapEnd:
